CREATE OR REPLACE VIEW OC3.LOAN_VIEW
(   USER_KEY,
    TYPE,
    BOOK_CODE,
    CLASS_NO,
    COPY_CODE,
    MANAGE_CODE,
    PREV_WORKING_STATUS,
    PRICE,
    BB_REC_KEY,
    REG_NO,
    SEPARATE_SHELF_CODE,
    VOL_CODE,
    WORKING_STATUS,
    DELAY_CNT,
    PUBLISH_FORM_CODE,
    REC_KEY,
    RESERVATION_EXPIRE_DATE,
    RETURN_PLAN_DATE,
    SHELF_LOC_CODE,
    STATUS,
    VOL_TITLE,
    TITLE,
    IB_REC_KEY,
    LOAN_DATE,
    RESERVATION_DATE,
    LOAN_MANAGE_CODE,
    RESERVE_USER_CNT,
    REG_CODE,
    IDX_TITLE,
    L_DEVICE,
    R_DEVICE
)
AS
SELECT CL.USER_KEY,
       BB.BOOK_APPENDIX_FLAG,
       BB.BOOK_CODE,
       BB.CLASS_NO,
       BB.COPY_CODE,
       BB.MANAGE_CODE,
       BB.PREV_WORKING_STATUS,
       BB.PRICE,
       BB.REC_KEY,
       BB.REG_NO,
       BB.SEPARATE_SHELF_CODE,
       BB.VOL_CODE,
       BB.WORKING_STATUS,
       CL.DELAY_CNT,
       CL.PUBLISH_FORM_CODE,
       CL.REC_KEY,
       TO_CHAR (CL.RESERVATION_EXPIRE_DATE, 'YYYY/MM/DD'),
       TO_CHAR (CL.RETURN_PLAN_DATE, 'YYYY/MM/DD'),
       CL.SHELF_LOC_CODE,
       CL.STATUS,
       DECODE (BB.BOOK_APPENDIX_FLAG, 'A', NULL, 'B', CONCAT (CONCAT (BB.VOL, '/'), BB.VOL_TITLE) ),
       DECODE (BB.BOOK_APPENDIX_FLAG, 'A', BB.VOL_TITLE, 'B', IB.TITLE_INFO ),
       IB.REC_KEY,
       TO_CHAR (CL.LOAN_DATE, 'YYYY/MM/DD HH24:MI'),
       TO_CHAR (CL.RESERVATION_DATE, 'YYYY/MM/DD HH24:MI'),
       CL.LOAN_MANAGE_CODE,
       (SELECT COUNT (*)
        FROM   OC3.LH_STORAGE_V01 CL2
        WHERE  CL2.BOOK_KEY = BB.REC_KEY
        AND    CL2.STATUS = '3'),
       BB.REG_CODE,
       IB.IDX_TITLE,
       CL.L_DEVICE,
       CL.R_DEVICE
FROM   LH_STORAGE_V01 CL,
       KOLAS.BO_BOOK_TBL BB,
       KOLAS.IDX_BO_TBL IB
WHERE  CL.BOOK_KEY = BB.REC_KEY
AND    BB.SPECIES_KEY = IB.REC_KEY
AND    CL.STATUS IN ('0', '2', '3')
UNION
SELECT CL.USER_KEY,
       BB.BOOK_TYPE,
       BB.BOOK_CODE,
       BB.CLASS_NO,
       BB.COPY_CODE,
       BB.MANAGE_CODE,
       BB.PREV_WORKING_STATUS,
       V.PRICE,
       BB.REC_KEY,
       BB.REG_NO,
       IB.SE_SHELF_CODE,
       BB.VOL_CODE,
       BB.WORKING_STATUS,
       CL.DELAY_CNT,
       CL.PUBLISH_FORM_CODE,
       CL.REC_KEY,
       TO_CHAR (CL.RESERVATION_EXPIRE_DATE, 'YYYY/MM/DD'),
       TO_CHAR (CL.RETURN_PLAN_DATE, 'YYYY/MM/DD'),
       CL.SHELF_LOC_CODE,
       CL.STATUS,
       DECODE (BB.BOOK_TYPE, 'A', NULL, 'B', V.VOL_TITLE, 'C', V.VOL_TITLE ),
       DECODE (BB.BOOK_TYPE, 'A', V.VOL_TITLE, 'B', IB.TITLE_INFO, 'C', IB.TITLE_INFO ),
       IB.REC_KEY,
       TO_CHAR (CL.LOAN_DATE, 'YYYY/MM/DD HH24:MI'),
       TO_CHAR (CL.RESERVATION_DATE, 'YYYY/MM/DD HH24:MI'),
       CL.LOAN_MANAGE_CODE,
       (SELECT COUNT (*)
        FROM   LH_STORAGE_V01 CL2
        WHERE  CL2.BOOK_KEY = BB.REC_KEY
        AND    CL2.STATUS = '3'),
       BB.REG_CODE,
       IB.IDX_TITLE,
       CL.L_DEVICE,
       CL.R_DEVICE
FROM   LH_STORAGE_V01 CL,
       KOLAS.SE_BOOK_TBL BB,
       KOLAS.IDX_SE_TBL IB,
       KOLAS.SE_VOL_TBL V
WHERE  CL.BOOK_KEY = BB.REC_KEY
AND    BB.SPECIES_KEY = IB.REC_KEY
AND    BB.VOL_KEY = V.REC_KEY
AND    CL.STATUS IN ('0', '2', '3')
UNION
SELECT CL.USER_KEY,
       'B',
       NULL,
       NULL,
       NULL,
       NB.MANAGE_CODE,
       NB.PREV_WORKING_STATUS,
       NB.PRICE,
       NB.REC_KEY,
       NB.REG_NO,
       NB.SEPARATE_SHELF_CODE,
       NULL,
       NB.WORKING_STATUS,
       CL.DELAY_CNT,
       CL.PUBLISH_FORM_CODE,
       CL.REC_KEY,
       TO_CHAR (CL.RESERVATION_EXPIRE_DATE, 'YYYY/MM/DD'),
       TO_CHAR (CL.RETURN_PLAN_DATE, 'YYYY/MM/DD'),
       CL.SHELF_LOC_CODE,
       CL.STATUS,
       NULL,
       NB.TITLE,
       1,
       TO_CHAR (CL.LOAN_DATE, 'YYYY/MM/DD HH24:MI'),
       TO_CHAR (CL.RESERVATION_DATE, 'YYYY/MM/DD HH24:MI'),
       CL.LOAN_MANAGE_CODE,
       0,
       NB.REG_CODE,
       NB.TITLE,
       CL.L_DEVICE,
       CL.R_DEVICE
FROM   LH_STORAGE_V01 CL,
       KOLAS.CO_NON_DB_BOOK_TBL NB
WHERE  CL.BOOK_KEY = NB.REC_KEY
AND    CL.STATUS IN ('0', '2', '3');

CREATE SYNONYM KOLAS.LOAN_VIEW FOR OC3.LOAN_VIEW;